/**
 * Raster based 6x6 font heavily based on SilkScreen (http://kottke.org/plus/type/silkscreen/).
 */
function BlockFont() {}
BlockFont.charMap = {
    "A":[
        [0,1,1,0],
        [1,0,0,1],
        [1,1,1,1],
        [1,0,0,1],
        [1,0,0,1]
    ],
    "B":[
        [1,1,1,0],
        [1,0,0,1],
        [1,1,1,0],
        [1,0,0,1],
        [1,1,1,1]
    ],
    "C":[
        [0,1,1,0],
        [1,0,0,1],
        [1,0,0,0],
        [1,0,0,1],
        [0,1,1,0]
    ],
    "D":[
        [1,1,1,0],
        [1,0,0,1],
        [1,0,0,1],
        [1,0,0,1],
        [1,1,1,0]
    ],
    "E":[
        [1,1,1,1],
        [1,0,0,0],
        [1,1,1,1],
        [1,0,0,0],
        [1,1,1,1]
    ],
    "F":[
        [1,1,1,1],
        [1,0,0,0],
        [1,1,1,0],
        [1,0,0,0],
        [1,0,0,0]
    ],
    "G":[
        [0,1,1,1],
        [1,0,0,0],
        [1,0,1,1],
        [1,0,0,1],
        [1,1,1,0]
    ],
    "H":[
        [1,0,0,1],
        [1,0,0,1],
        [1,1,1,1],
        [1,0,0,1],
        [1,0,0,1]
    ],
    "I":[
        [1],
        [1],
        [1],
        [1],
        [1]
    ],
    "J":[
        [0,0,0,1],
        [0,0,0,1],
        [0,0,0,1],
        [1,0,0,1],
        [0,1,1,0]
    ],
    "K":[
        [1,0,0,1],
        [1,0,1,0],
        [1,1,0,0],
        [1,0,1,0],
        [1,0,0,1]
    ],
    "L":[
        [1,0,0],
        [1,0,0],
        [1,0,0],
        [1,0,0],
        [1,1,1]
    ],
    "M":[
        [1,0,0,0,1],
        [1,1,0,1,1],
        [1,0,1,0,1],
        [1,0,0,0,1],
        [1,0,0,0,1]
    ],
    "N":[
        [1,0,0,0,1],
        [1,1,0,0,1],
        [1,0,1,0,1],
        [1,0,0,1,1],
        [1,0,0,0,1]
    ],
    "O":[
        [0,1,1,0],
        [1,0,0,1],
        [1,0,0,1],
        [1,0,0,1],
        [0,1,1,0]
    ],
    "P":[
        [1,1,1,0],
        [1,0,0,1],
        [1,1,1,0],
        [1,0,0,0],
        [1,0,0,0]
    ],
    "Q":[
        [0,1,1,0],
        [1,0,0,1],
        [1,0,0,1],
        [1,0,0,1],
        [0,1,1,0],
        [0,0,0,1]
    ],
    "R":[
        [1,1,1,0],
        [1,0,0,1],
        [1,1,1,0],
        [1,0,1,0],
        [1,0,0,1]
    ],
    "S":[
        [0,1,1,1],
        [1,0,0,0],
        [0,1,1,0],
        [0,0,0,1],
        [1,1,1,0]
    ],
    "T":[
        [1,1,1],
        [0,1,0],
        [0,1,0],
        [0,1,0],
        [0,1,0]
    ],
    "U":[
        [1,0,0,1],
        [1,0,0,1],
        [1,0,0,1],
        [1,0,0,1],
        [0,1,1,0]
    ],
    "V":[
        [1,0,0,0,1],
        [1,0,0,0,1],
        [0,1,0,1,0],
        [0,1,0,1,0],
        [0,0,1,0,0]
    ],
    "W":[
        [1,0,0,0,1],
        [1,0,1,0,1],
        [1,0,1,0,1],
        [1,0,1,0,1],
        [0,1,0,1,0]
    ],
    "X":[
        [1,0,0,0,1],
        [0,1,0,1,0],
        [0,0,1,0,0],
        [0,1,0,1,0],
        [1,0,0,0,1]
    ],
    "Y":[
        [1,0,0,0,1],
        [0,1,0,1,0],
        [0,0,1,0,0],
        [0,0,1,0,0],
        [0,0,1,0,0]
    ],
    "Z":[
        [1,1,1,1],
        [0,0,0,1],
        [0,0,1,0],
        [0,1,0,0],
        [1,1,1,1]
    ],
    "a":[
        [0,0,0,0],
        [0,1,1,1],
        [1,0,0,1],
        [1,0,0,1],
        [0,1,1,1],
    ],
    "b":[
        [1,0,0,0],
        [1,0,0,0],
        [1,1,1,0],
        [1,0,0,1],
        [1,1,1,0],
    ],
    "c":[
        [0,0,0],
        [0,1,1],
        [1,0,0],
        [1,0,0],
        [0,1,1],
    ],
    "d":[
        [0,0,0,1],
        [0,0,0,1],
        [0,1,1,1],
        [1,0,0,1],
        [0,1,1,1],
    ],
    "e":[
        [0,0,0,0],
        [0,1,1,0],
        [1,0,0,1],
        [1,1,1,0],
        [0,1,1,1],
    ],
    "f":[
        [0,0,1],
        [0,1,0],
        [1,1,1],
        [0,1,0],
        [0,1,0],
    ],
    "g":[
        [0,0,0,0],
        [0,1,1,1],
        [1,0,0,1],
        [0,1,1,1],
        [0,0,0,1],
        [1,1,1,0],
    ],
    "h":[
        [1,0,0,0],
        [1,0,0,0],
        [1,1,1,0],
        [1,0,0,1],
        [1,0,0,1],
    ],
    "i":[
        [1],
        [0],
        [1],
        [1],
        [1],
    ],
    "j":[
        [0,0,1],
        [0,0,0],
        [0,0,1],
        [0,0,1],
        [0,0,1],
        [1,1,0],
    ],
    "k":[
        [1,0,0,0],
        [1,0,0,1],
        [1,0,1,0],
        [1,1,1,0],
        [1,0,0,1],
    ],
    "l":[
        [1],
        [1],
        [1],
        [1],
        [1],
    ],
    "m":[
        [0,0,0,0,0],
        [1,1,1,1,0],
        [1,0,1,0,1],
        [1,0,1,0,1],
        [1,0,1,0,1],
    ],
    "n":[
        [0,0,0,0],
        [1,1,1,0],
        [1,0,0,1],
        [1,0,0,1],
        [1,0,0,1],
    ],
    "o":[
        [0,0,0,0],
        [0,1,1,0],
        [1,0,0,1],
        [1,0,0,1],
        [0,1,1,0],
    ],
    "p":[
        [0,0,0,0],
        [1,1,1,0],
        [1,0,0,1],
        [1,1,1,0],
        [1,0,0,0],
        [1,0,0,0],
    ],
    "q":[
        [0,0,0,0],
        [0,1,1,1],
        [1,0,0,1],
        [0,1,1,1],
        [0,0,0,1],
        [0,0,0,1]
    ],
    "r":[
        [0,0,0,0],
        [1,0,1,1],
        [1,1,0,0],
        [1,0,0,0],
        [1,0,0,0],
    ],
    "s":[
        [0,0,0,0],
        [0,1,1,1],
        [1,1,0,0],
        [0,0,1,1],
        [1,1,1,0],
    ],
    "t":[
        [0,1,0],
        [1,1,1],
        [0,1,0],
        [0,1,0],
        [0,0,1],
    ],
    "u":[
        [0,0,0,0],
        [1,0,0,1],
        [1,0,0,1],
        [1,0,0,1],
        [0,1,1,1],
    ],
    "v":[
        [0,0,0],
        [1,0,1],
        [1,0,1],
        [1,0,1],
        [0,1,0],
    ],
    "w":[
        [0,0,0,0,0],
        [1,0,1,0,1],
        [1,0,1,0,1],
        [0,1,0,1,0],
        [0,1,0,1,0],
    ],
    "x":[
        [0,0,0],
        [1,0,1],
        [0,1,0],
        [0,1,0],
        [1,0,1],
    ],
    "y":[
        [0,0,0,0],
        [1,0,0,1],
        [1,0,0,1],
        [0,1,1,1],
        [0,0,0,1],
        [0,1,1,0]
    ],
    "z":[
        [0,0,0,0],
        [1,1,1,1],
        [0,0,1,0],
        [0,1,0,0],
        [1,1,1,1],
    ],
    "1":[
        [1,1,0],
        [0,1,0],
        [0,1,0],
        [0,1,0],
        [1,1,1]
    ],
    "2":[
        [1,1,1,0],
        [0,0,0,1],
        [0,1,1,0],
        [1,0,0,0],
        [1,1,1,1]
    ],
    "3":[
        [1,1,1,0],
        [0,0,0,1],
        [0,1,1,0],
        [0,0,0,1],
        [1,1,1,0]
    ],
    "4":[
        [1,0,1,0],
        [1,0,1,0],
        [1,1,1,1],
        [0,0,1,0],
        [0,0,1,0]
    ],
    "5":[
        [1,1,1,1],
        [1,0,0,0],
        [1,1,1,0],
        [0,0,0,1],
        [1,1,1,0]
    ],
    "6":[
        [0,1,1,0],
        [1,0,0,0],
        [1,1,1,0],
        [1,0,0,1],
        [0,1,1,0]
    ],
    "7":[
        [1,1,1,1],
        [0,0,0,1],
        [0,0,1,0],
        [0,1,0,0],
        [0,1,0,0]
    ],
    "8":[
        [0,1,1,0],
        [1,0,0,1],
        [0,1,1,0],
        [1,0,0,1],
        [0,1,1,0]
    ],
    "9":[
        [0,1,1,0],
        [1,0,0,1],
        [0,1,1,1],
        [0,0,0,1],
        [0,1,1,0]
    ],
    "0":[
        [0,1,1,0],
        [1,0,0,1],
        [1,0,0,1],
        [1,0,0,1],
        [0,1,1,0]
    ],
    ".":[
        [0,0],
        [0,0],
        [0,0],
        [0,0],
        [1,0]
    ],
    ":":[
        [0,0],
        [1,0],
        [0,0],
        [1,0],
        [0,0]
    ],
    ",":[
        [0,0],
        [0,0],
        [0,0],
        [0,0],
        [0,1],
        [1,0]
    ],
    "'":[
        [0,1,0],
        [0,1,0],
        [0,0,0],
        [0,0,0],
        [0,0,0]
    ],
    "`":[
        [0,1,0,0],
        [0,0,1,0],
        [0,0,0,0],
        [0,0,0,0],
        [0,0,0,0]
    ],
    "\"":[
        [0,1,0,1],
        [0,1,0,1],
        [0,0,0,0],
        [0,0,0,0],
        [0,0,0,0]
    ],
    ")":[
        [0,1,0],
        [0,0,1],
        [0,0,1],
        [0,0,1],
        [0,1,0]
    ],
    "(":[
        [0,1,0],
        [1,0,0],
        [1,0,0],
        [1,0,0],
        [0,1,0]
    ],
    "!":[
        [0,1,0],
        [0,1,0],
        [0,1,0],
        [0,0,0],
        [0,1,0]
    ],
    "?":[
        [1,1,1,0],
        [0,0,0,1],
        [0,1,1,0],
        [0,0,0,0],
        [0,1,0,0]
    ],
    "+":[
        [0,0,1,0,0],
        [0,0,1,0,0],
        [1,1,1,1,1],
        [0,0,1,0,0],
        [0,0,1,0,0]
    ],
    "-":[
        [0,0,0,0],
        [0,0,0,0],
        [1,1,1,1],
        [0,0,0,0],
        [0,0,0,0]
    ],
    "*":[
        [0,0,1,0,0],
        [1,0,1,0,1],
        [0,1,1,1,0],
        [1,0,1,0,1],
        [0,0,1,0,0]
    ],
    "/":[
        [0,0,0,0,1],
        [0,0,0,1,0],
        [0,0,1,0,0],
        [0,1,0,0,0],
        [1,0,0,0,0]
    ],
    "\\":[
        [1,0,0,0,0],
        [0,1,0,0,0],
        [0,0,1,0,0],
        [0,0,0,1,0],
        [0,0,0,0,1]
    ],
    "=":[
        [0,0,0,0],
        [1,1,1,1],
        [0,0,0,0],
        [1,1,1,1],
        [0,0,0,0]
    ],
    "$":[
        [0,0,1,0],
        [0,1,1,1],
        [1,0,0,0],
        [0,1,1,0],
        [0,0,0,1],
        [1,1,1,0],
        [0,0,1,0]
    ],
    "^":[
        [0,1,0],
        [1,0,1],
        [0,0,0],
        [0,0,0],
        [0,0,0]
    ],
    "@":[
        [0,1,1,1,0],
        [1,0,1,0,1],
        [1,0,1,1,0],
        [1,0,0,0,0],
        [0,1,1,1,0]
    ],
    "#":[
        [0,1,0,1,0],
        [1,1,1,1,1],
        [0,1,0,1,0],
        [1,1,1,1,1],
        [0,1,0,1,0]
    ],
    "%":[
        [1,1,0,0,1],
        [1,1,0,1,0],
        [0,0,1,0,0],
        [0,1,0,1,1],
        [1,0,0,1,1]
    ],
    "[":[
        [1,1,],
        [1,0,],
        [1,0,],
        [1,0,],
        [1,1,]
    ],
    "]":[
        [1,1],
        [0,1],
        [0,1],
        [0,1],
        [1,1]
    ],
    "<":[
        [0,0,1],
        [0,1,0],
        [1,0,0],
        [0,1,0],
        [0,0,1]
    ],
    ">":[
        [1,0,0],
        [0,1,0],
        [0,0,1],
        [0,1,0],
        [1,0,0]
    ],
    "|":[
        [1],
        [1],
        [1],
        [1],
        [1],
        [1],
        [1]
    ],
    ";":[
        [0,0,0],
        [0,1,0],
        [0,0,0],
        [0,1,0],
        [1,0,0]
    ],
    " ": [
        [0,0],
        [0,0],
        [0,0],
        [0,0],
        [0,0]
    ],
    "\u2190": [
        [0,0,1,0,0,0],
        [0,1,1,0,0,0],
        [1,1,1,1,1,1],
        [0,1,1,0,0,0],
        [0,0,1,0,0,0]
    ],
    "\u2191": [
        [0,0,1,0,0],
        [0,1,1,1,0],
        [1,1,1,1,1],
        [0,0,1,0,0],
        [0,0,1,0,0],
        [0,0,1,0,0]
    ],
    "\u2192": [
        [0,0,0,1,0,0],
        [0,0,0,1,1,0],
        [1,1,1,1,1,1],
        [0,0,0,1,1,0],
        [0,0,0,1,0,0]
    ],
    "\u2193": [
        [0,0,1,0,0],
        [0,0,1,0,0],
        [0,0,1,0,0],
        [1,1,1,1,1],
        [0,1,1,1,0],
        [0,0,1,0,0]
    ],
    "&":[
        [0,1,0,0],
        [1,0,1,0],
        [0,1,1,0],
        [1,0,1,0],
        [1,1,1,1]
    ],
    "~": [
        [0,0,0,0,0],
        [0,1,0,0,0],
        [1,0,1,0,1],
        [0,0,0,1,0],
        [0,0,0,0,0]
    ],
    "{": [
        [0,1,1,0],
        [0,1,0,0],
        [1,0,0,0],
        [0,1,0,0],
        [0,1,1,0]
    ],
    "}": [
        [0,1,1,0],
        [0,0,1,0],
        [0,0,0,1],
        [0,0,1,0],
        [0,1,1,0]
    ],
    "_": [
        [0,0,0,0,0],
        [0,0,0,0,0],
        [0,0,0,0,0],
        [0,0,0,0,0],
        [1,1,1,1,1]
    ],
};
BlockFont.fillText = function(ctx,text,x,y,alignment,color,size) {
    var i;

    //We need to handle multi-line messages as multiple single line messages.
    if(text.indexOf("\n")>=0) {
        var bits = text.split("\n");
        for(i=0;i<bits.length;i++) {
            BlockFont.fillText(ctx,bits[i],x,y+(i*7),alignment,color,size);
        }
        return;
    }

    if(!alignment) {
        alignment = "left";
    }
    if(!color) {
        color = [0,0,0];
    }
    if(size) {
        text = BlockFont.trimTextToSize(text,size);
    }

    if(alignment==="right") {
        x -= BlockFont.calculateWidth(text);
    } else if(alignment==="center") {
        x -= Math.floor(BlockFont.calculateWidth(text)/2);
    }

    var offsetX = x;
    var aY, cW, cH;
    for(i=0;i<text.length;i++) {
        var c = text.charAt(i);
        if(this.charMap[c]) {
            var map = this.charMap[c];

            var descender = map.length>5;
            var ascender = map.length>6;

            aY = (ascender)?(y-1):y;
            cH = (descender)?6:5;
            if(ascender) {
                cH++;
            }
            cW = map[0].length;

            var img = ctx.getImageData(offsetX,aY,cW,cH);
            var pX,pY;
            var arrOffset = 0;
            for(pY=0;pY<cH;pY++) {
                for(pX=0;pX<cW;pX++) {
                    if(map[pY][pX]===1) {
                        img.data[arrOffset]=color[0];
                        img.data[arrOffset+1]=color[1];
                        img.data[arrOffset+2]=color[2];
                        img.data[arrOffset+3]=0xFF;
                    }
                    arrOffset+=4;
                }
            }
            ctx.putImageData(img,offsetX,aY);
            offsetX += cW+1;
        }
    }
};
BlockFont.calculateWidth = function(text) {
    var i;
    var width = 0;
    for(i=0;i<text.length;i++) {
        var c = text.charAt(i);
        if(BlockFont.charMap[c]) {
            width += BlockFont.charMap[c][0].length+1;
        }
    }
    return width-1;
};
BlockFont.trimTextToSize = function(text,size) {
    var eSize = BlockFont.calculateWidth("...");
    var i;
    var width = 0;
    for(i=0;i<text.length;i++) {
        var c = text.charAt(i);
        if(BlockFont.charMap[c]) {
            var w = BlockFont.charMap[c][0].length;
            if(width+w+eSize>size) {
                return text.substring(0,i)+"...";
            }
            width += w+1;
        }
    }
    return text;
};

if(typeof module === "object" && module.exports) {
    module.exports = BlockFont;
}